VERSION 5.00
Object = "{84E5CF37-E467-4AC2-89C4-C6002FFB5055}#25.1#0"; "ChartViewer.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7380
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   13830
   LinkTopic       =   "Form1"
   ScaleHeight     =   7380
   ScaleWidth      =   13830
   StartUpPosition =   3  'Windows Default
   Begin VB.OptionButton PointerPB 
      Height          =   360
      Left            =   0
      Picture         =   "Form1.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   120
      Value           =   -1  'True
      Width           =   1725
   End
   Begin VB.OptionButton ZoomInPB 
      Height          =   360
      Left            =   0
      Picture         =   "Form1.frx":0D5A
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   465
      Width           =   1725
   End
   Begin VB.OptionButton ZoomOutPB 
      Height          =   360
      Left            =   0
      Picture         =   "Form1.frx":1AB4
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   810
      Width           =   1725
   End
   Begin CDChartViewer.ChartViewer ChartViewer1 
      Height          =   7200
      Left            =   1800
      Top             =   120
      Width           =   12000
      _ExtentX        =   21167
      _ExtentY        =   12700
      ZoomDirection   =   2
      ScrollDirection =   2
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private startDate()
Private endDate()
Private labels()

' The full x-axis and y-axis scales at no zooming.
Private minX As Double
Private maxX As Double
Private minY As Double
Private maxY As Double

Private Sub Form_Load()
    ' Initially, set mouse usage to pointer mode
    Call PointerPB_Click
    
    ' data for the gantt chart, representing the start date, end date and names for various
    ' activities
    startDate = Array(DateSerial(2004, 8, 16), DateSerial(2004, 8, 30), DateSerial(2004, 9, 13), _
        DateSerial(2004, 9, 20), DateSerial(2004, 9, 27), DateSerial(2004, 10, 4), DateSerial( _
        2004, 10, 25), DateSerial(2004, 11, 1), DateSerial(2004, 11, 8), _
        DateSerial(2004, 8, 16), DateSerial(2004, 8, 30), DateSerial(2004, 9, 13), _
        DateSerial(2004, 9, 20), DateSerial(2004, 9, 27), DateSerial(2004, 10, 4), DateSerial( _
        2004, 10, 25), DateSerial(2004, 11, 1), DateSerial(2004, 11, 8))
    endDate = Array(DateSerial(2004, 8, 30), DateSerial(2004, 9, 13), DateSerial(2004, 9, 27), _
        DateSerial(2004, 10, 4), DateSerial(2004, 10, 11), DateSerial(2004, 11, 8), DateSerial( _
        2004, 11, 8), DateSerial(2004, 11, 22), DateSerial(2004, 11, 22), _
        DateSerial(2004, 8, 30), DateSerial(2004, 9, 13), DateSerial(2004, 9, 27), _
        DateSerial(2004, 10, 4), DateSerial(2004, 10, 11), DateSerial(2004, 11, 8), DateSerial( _
        2004, 11, 8), DateSerial(2004, 11, 22), DateSerial(2004, 11, 22))
    labels = Array("Market Research", "Define Specifications", "Overall Archiecture", _
        "Project Planning", "Detail Design", "Software Development", "Test Plan", _
        "Testing and QA", "User Documentation", _
        "AAAA", "BBBB", "CCCC", "DDDD", "EEEE", "FFFF", "GGGG", "HHHH", "IIII")

    Dim cd As New ChartDirector.API
    minX = 0
    maxX = UBound(labels)
    minY = cd.CTime(startDate(9))
    maxY = cd.CTime(endDate(UBound(endDate)))
    
    Call drawChart(ChartViewer1)
End Sub

'
' User clicks on the Pointer pushbutton
'
Private Sub PointerPB_Click()
    ChartViewer1.MouseUsage = cvScrollOnDrag
End Sub

'
' User clicks on the Zoom In pushbutton
'
Private Sub ZoomInPB_Click()
    ChartViewer1.MouseUsage = cvZoomIn
End Sub

'
' User clicks on the Zoom Out pushbutton
'
Private Sub ZoomOutPB_Click()
    ChartViewer1.MouseUsage = cvZoomOut
End Sub

'
' The ViewPortChanged event handler.
'
Private Sub ChartViewer1_ViewPortChanged(needUpdateChart As Boolean, needUpdateImageMap As Boolean)
    If needUpdateChart Then Call drawChart(ChartViewer1)
End Sub


'Main code for creating chart.
'Note: the argument chartIndex is unused because this demo only has 1 chart
Public Sub drawChart(viewer As Object)

    Dim cd As New ChartDirector.API

    ' Create a XYChart object of size 620 x 280 pixels. Set background color to light blue (ccccff),
    ' with 1 pixel 3D border effect.
    Dim c As XYChart
    Set c = cd.XYChart(800, 480)

    Call c.setPlotArea(150, 40, 600, 400, &HFFFFFF, &HEEEEEE, cd.linecolor, &HC0C0C0, &HC0C0C0 _
        ).setGridWidth(2, 1, 1, 1)

    ' swap the x and y axes to create a horziontal box-whisker chart
    Call c.swapXY
    Call c.setClipping

    ' Set multi-style axis label formatting. Month labels are in Arial Bold font in "mmm d" format.
    ' Weekly labels just show the day of month and use minor tick (by using '-' as first character
    ' of format string).
    Call c.yAxis().setMultiFormat(cd.StartOfMonthFilter(), "<*font=arialbd.ttf*>{value|mmm d}", _
        cd.StartOfDayFilter(), "-{value|d}")

    ' Set the y-axis to shown on the top (right + swapXY = top)
    Call c.setYAxisOnRight

    ' Reverse the x-axis scale so that it points downwards.
    Call c.xAxis().setReverse

    ' Add a green (33ff33) box-whisker layer showing the box only.
    Call c.addBoxWhiskerLayer(startDate, endDate, Empty, Empty, Empty, &HCC00, _
        cd.SameAsMainColor, cd.SameAsMainColor)

    ' Compute the zoomed-in axis scales using the overall axis scales and ViewPort size
    Dim xScaleMin As Double
    Dim xScaleMax As Double
    Dim yScaleMin As Double
    Dim yScaleMax As Double

    xScaleMin = minX + (maxX - minX) * ChartViewer1.ViewportTop
    xScaleMax = minX + (maxX - minX) * (ChartViewer1.ViewportTop + ChartViewer1.ViewportHeight)
    yScaleMin = minY + (maxY - minY) * ChartViewer1.ViewportLeft
    yScaleMax = minY + (maxY - minY) * (ChartViewer1.ViewportLeft + ChartViewer1.ViewportWidth)
    
    ' Set the axis scales
    Call c.xAxis().setLinearScale(xScaleMin, xScaleMax, cd.NoValue)
    Call c.xAxis().setRounding(False, False)
    Call c.yAxis().setDateScale(yScaleMin, yScaleMax)
    Call c.yAxis().setRounding(False, False)
           
    ' Set the x-axis labels and the ticks
    Dim i As Long
    For i = Int(xScaleMin) To xScaleMax + 1
        If i <= UBound(labels) Then Call c.xAxis().addLabel(i, "~" & labels(i))
        Call c.xAxis().addLabel(i - 0.5, " ")
    Next
        
    ' Output the chart
    Set viewer.Chart = c

    'include tool tip for the chart
    viewer.ImageMap = c.getHTMLImageMap("clickable", "", _
        "title='{xLabel}: {top|mmm dd, yyyy} to {bottom|mmm dd, yyyy}'")

End Sub

